﻿Public Class MyPageSetupDialog

    Private _PrinterSettings As Printing.PrinterSettings
    Private _PageSettings As MyPageSettings
    Private _EnableMetric As Boolean

    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub

    Public Function ShowDialog() As DialogResult
        Dim frmDlg As New dlgMyPageSetupDialog
        If _PageSettings Is Nothing Then
            _PageSettings = New MyPageSettings(GetDefaultPrinterSettings())
        End If
        frmDlg.PageSettings = DirectCast(_PageSettings.Clone, MyPageSettings)
        If _PrinterSettings IsNot Nothing Then
            frmDlg.PrinterSettings = DirectCast(_PrinterSettings.Clone,  _
                Printing.PrinterSettings)
        End If
        frmDlg.EnableMetric = _EnableMetric
        Dim dlgresult As DialogResult = frmDlg.ShowDialog()
        If dlgresult = DialogResult.OK Then
            _PageSettings = DirectCast(frmDlg.PageSettings.Clone,  _
                MyPageSettings)
            _PrinterSettings = _PageSettings.PrinterSettings
        End If
        Return dlgresult
    End Function

    Private Function GetDefaultPrinterSettings() As Printing.PrinterSettings
        Dim prs As New Printing.PrinterSettings
        For Each prtn As String In Printing.PrinterSettings.InstalledPrinters
            prs.PrinterName = prtn
            If prs.IsDefaultPrinter Then
                Return prs
            End If
        Next
        Return Nothing
    End Function

    Public Property PageSettings() As MyPageSettings
        Get
            Return _PageSettings
        End Get
        Set(ByVal value As MyPageSettings)
            _PageSettings = value
        End Set
    End Property

    Public Property PrinterSettings() As Printing.PrinterSettings
        Get
            Return _PrinterSettings
        End Get
        Set(ByVal value As Printing.PrinterSettings)
            _PrinterSettings = value
        End Set
    End Property

    Public Property EnableMetric() As Boolean
        Get
            Return _enableMetric
        End Get
        Set(ByVal value As Boolean)
            _enableMetric = value
        End Set
    End Property
End Class
