﻿Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports System.Management

Public Class dlgMyPrinterSettings

    Private Declare Function OpenPrinter Lib "winspool.drv" _
        Alias "OpenPrinterA" (ByVal pPrinterName As String, _
                              ByRef phPrinter As IntPtr, _
                              ByVal pDefault As IntPtr) As Int32
    Private Declare Function PrinterProperties Lib "winspool.drv" ( _
        ByVal hWnd As IntPtr, ByVal hPrinter As IntPtr) As Int32
    Private Declare Function ClosePrinter Lib "winspool.drv" ( _
        ByVal hPrinter As IntPtr) As Int32

    Private Enum PrinterStatus
        Sonstiger = 1
        Unbekannt = 2
        Bereit = 3
        Druckt = 4
        Aufwärmen = 5
        Angehalten = 6
        Offline = 7
    End Enum

    Private _PrinterSettings As Printing.PrinterSettings

    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf 
        '  hinzu.
        For Each s As String In Printing.PrinterSettings.InstalledPrinters
            cbxPrintername.Items.Add(s)
        Next
    End Sub

    Public Property PrinterSettings() As Printing.PrinterSettings
        Get
            Return _PrinterSettings
        End Get
        Set(ByVal value As Printing.PrinterSettings)
            _PrinterSettings = DirectCast(value.Clone, Printing.PrinterSettings)
            cbxPrintername.SelectedItem = _PrinterSettings.PrinterName
        End Set
    End Property

    Private Sub btnOK_Click(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) Handles btnOK.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnCancel.Click

        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub cbxPrintername_SelectedIndexChanged( _
            ByVal sender As Object, _
            ByVal e As System.EventArgs) _
            Handles cbxPrintername.SelectedIndexChanged

        _PrinterSettings.PrinterName = cbxPrintername.SelectedItem.ToString
        ShowPrinterStatus()
    End Sub

    Private Sub ShowPrinterStatus()
        Dim sQuery As String = "SELECT * FROM Win32_Printer WHERE Caption='" & _
            _PrinterSettings.PrinterName & "'"
        Dim Printerssearch As New ManagementObjectSearcher(sQuery)
        Dim printers As ManagementObjectCollection = Printerssearch.Get
        Dim prtcapt As String
        For Each prt As ManagementObject In printers
            prtcapt = prt.GetPropertyValue("Caption").ToString
            If prtcapt = _PrinterSettings.PrinterName Then
                lblStatus.Text = ""
                lblTyp.Text = ""
                lblLocation.Text = ""
                lblComment.Text = ""
                For Each prop As PropertyData In prt.Properties
                    Select Case prop.Name
                        Case "PrinterStatus"
                            If prop.Value IsNot Nothing Then
                                lblStatus.Text = DirectCast(CInt(prop.Value),  _
                                    PrinterStatus).ToString
                            End If
                        Case "DriverName"
                            If prop.Value IsNot Nothing Then
                                lblTyp.Text = prop.Value.ToString
                            End If
                        Case "PortName"
                            If prop.Value IsNot Nothing Then
                                lblLocation.Text = prop.Value.ToString
                            End If
                        Case "Comment"
                            If prop.Value IsNot Nothing Then
                                lblComment.Text = prop.Value.ToString
                            End If
                    End Select
                Next
            End If
        Next
    End Sub

    Private Sub btnPrinterProperties_Click(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles btnPrinterProperties.Click
        Dim hPrinter As IntPtr
        Dim retval As Int32

        retval = OpenPrinter(cbxPrintername.SelectedItem.ToString, _
                             hPrinter, Nothing)
        retval = PrinterProperties(Me.Handle, hPrinter)
        retval = ClosePrinter(hPrinter)
    End Sub

End Class
